uniform sampler2D RTScene; // the texture with the scene you want to blur

varying vec2 vTexCoord;

//rttWidth;
const float blurSize = 1.0/640.0; // every step will be one pixel wide if the RTScene texture is of size 512x512

void main(void)
{
   vec4 sum = vec4(0.0);

    //Added by me
    //vTexCoord
    vec2 TexCoord = gl_TexCoord[0].st;

    // blur in y (vertical)
    // take nine samples, with the distance blurSize between them
    sum += texture2D(RTScene, vec2(TexCoord.x - 4.0*blurSize, TexCoord.y)) * 0.05;
    sum += texture2D(RTScene, vec2(TexCoord.x - 3.0*blurSize, TexCoord.y)) * 0.09;
    sum += texture2D(RTScene, vec2(TexCoord.x - 2.0*blurSize, TexCoord.y)) * 0.12;
    sum += texture2D(RTScene, vec2(TexCoord.x - blurSize, TexCoord.y)) * 0.15;
    sum += texture2D(RTScene, vec2(TexCoord.x, TexCoord.y)) * 0.18;
    sum += texture2D(RTScene, vec2(TexCoord.x + blurSize, TexCoord.y)) * 0.15;
    sum += texture2D(RTScene, vec2(TexCoord.x + 2.0*blurSize, TexCoord.y)) * 0.12;
    sum += texture2D(RTScene, vec2(TexCoord.x + 3.0*blurSize, TexCoord.y)) * 0.09;
    sum += texture2D(RTScene, vec2(TexCoord.x + 4.0*blurSize, TexCoord.y)) * 0.05;

    gl_FragColor = sum;
}
