#ifndef IPLAYERANIMATOR_HPP
#define IPLAYERANIMATOR_HPP


#include <irrlicht.h>

#define DECLARE_PLAYER_MOVEFUNC_PARAMS   irr::core::vector3df& pos, \
                    irr::core::vector3df& rot, \
                    const IWalkyrieMode* mode, \
                    const irr::u32& elapsedTime, \
                    const SBindCache& MoveLeft, \
                    const SBindCache& MoveRight, \
                    const SBindCache& MoveForward, \
                    const SBindCache& MoveBackward


#define PLAYER_UPDATE_FUNCTION_PARAMS pos, \
                                    rot, \
                                    mode, \
                                    elapsedTime, \
                                    MoveLeft, \
                                    MoveRight, \
                                    MoveForward, \
                                    MoveBackward


class IPlayerAnimator;
class SBindCache;


class IWalkyrieMode;

class IPlayerAnimator
{
    public:
        IPlayerAnimator( const char* name) ;
        virtual ~IPlayerAnimator() ;

        virtual IPlayerAnimator* processMove( DECLARE_PLAYER_MOVEFUNC_PARAMS ) = 0;
        virtual void reset() = 0;

        const char * Name;
    protected:

    private:
};


class CSlidingPlayerAnimator  : public IPlayerAnimator
{
private:
    int _loopCount;
public:
    // Only on the left now
    CSlidingPlayerAnimator() : IPlayerAnimator("Sliding") {};
    IPlayerAnimator* processMove( DECLARE_PLAYER_MOVEFUNC_PARAMS );

    void reset();
};

#endif // IPLAYERANIMATOR_HPP
