/**
\file transforming.hpp
\brief
todo le rendre transformable

*/
#ifndef TRANSFORMING_HPP
#define TRANSFORMING_HPP

//#include "IEntity.hpp"
#include <map>
#include <list>
#include <fusion/macros.hpp>
#include <array>
#include <irrlicht.h>
#include <vector>
#include <fusion/logging/ILogger.hpp>
#include "SModeDescription.hpp"

using namespace irr;



// passer en parametre les noms des differents boosters, du mesh, ces caracteristiques
//template<std::size_t N>
// TODO Le transformer en Node

class ITransformer : public irr::scene::IAnimationEndCallBack
{
private:
    bool _transforming;
    irr::scene::IAnimatedMeshSceneNode* _animatedNode;

    irr::scene::IAnimationEndCallBack* _callback;

public:
    // TODO protected

    //irr::scene::IAnimatedMeshSceneNode* node = 0
    ITransformer();
    ~ITransformer();

    void setCallback(irr::scene::IAnimationEndCallBack* callback);

    irr::scene::IAnimatedMeshSceneNode* getNode() { return _animatedNode;};

    float getTransformationAdvancement();
//    void setTransformationAdvancement(const float&);

    bool isTransforming() const;

//    bool load(irr::scene::IAnimatedMeshSceneNode* node);
    void load(irr::scene::IAnimatedMeshSceneNode* node);

    bool targetFrame(const int& targetedFrame);


    virtual void OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode* node);

};

//#include "transforming.inl"

#endif
