/**
\file transforming.hpp
\brief
todo le rendre transformable

*/
#ifndef CWalkyrie_HPP
#define CWalkyrie_HPP

#include <initializer_list>.
#include <map>
#include <list>
#include <fusion/macros.hpp>
#include <array>
#include <irrlicht.h>
#include <vector>
#include <fusion/logging/ILogger.hpp>
//#include "IMultiModeTransformer.hpp"
#include "IWalkyrieMode.hpp"
#include "ITransformer.hpp"
#include "../def.hpp"


namespace SPK {
    namespace IRR {
        class IRRSystem;
    }
}

class IWalkyrieMode;
class CTransformingMode;


//class onTransformationEnd
//{
//
//public:
//    virtual void onTransformationEnd( IWalkyrie* , IWalkyrieMode*  finalMode) = 0;
//    virtual void onTransformationStart( IWalkyrie* ) = 0;
//    virtual void onTransformationUpdate( IWalkyrie* , IWalkyrieMode* from, IWalkyrieMode* to) = 0;
//};


// TODO    interpolate( 1.f, getModeFromModeId(_activeSpecs[_currentMode]), getModeFromModeId(_activeSpecs[_targetedMode]) );

//NWalkyrieModes::
class IWalkyrie :
//    public IMultiModeTransformer<EWalkyrieMode>
//    ,
//    public IWalkyrieMode,
    public irr::scene::IAnimationEndCallBack
    , public ITransformer

{

public:
//    typedef std::vector<IWalkyrieMode*> TModes;
//    static TModes Modes;
    //FighterMode

//    static IWalkyrieMode* ImmobileMode;
    static IWalkyrieMode* FighterMode;
    static IWalkyrieMode* GerwalkMode;
    static IWalkyrieMode *TransformingMode;
//    IWalkyrieMode* BattloidMode;

    IWalkyrieMode*  getCurrentMode() const {return _currentMode;};

    void forceMode(IWalkyrieMode* mode);
protected:
    IWalkyrieMode * _currentMode;
    IWalkyrieMode * _targetedMode;
//    CTransformingMode* _transformingMode;

    //typedef std::list<CStaticBattery*> TTrackedBatteries;
//    CMissile* _trackedMissile;


    // TODO remplacer par un tablo va dans IWalkyrie
    SPK::IRR::IRRSystem* _leftBooster;
    SPK::IRR::IRRSystem* _rightBooster;
//    irr::scene::IAnimatedMeshSceneNode* _animatedNode;

    void createBoosters();






public:
    const char* Name;


    // std::initializer_list
    IWalkyrie(const char* name);
    ~IWalkyrie();


    void OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode*);
//virtual void OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode* node);

    // Might throw ?
    void load(irr::scene::IAnimatedMeshSceneNode* node
//              , EWalkyrieMode const& mode
                , IWalkyrieMode* mode
              //, std::initializer_list<IWalkyrieMode*> modes
              );



//    bool setTargetedFrame(const int& targetedFrame);





//    float getTransformationAdvancement();

    /** \brief
     *
     * \param
     * \param
     * \return
     *
     */
    static void initialize();

    bool transformInto(IWalkyrieMode* mode);
    bool transformIntoNextMode();
    bool transformIntoPreviousMode();

    /** \brief Used to change mode parameters. From lua for instance
     *
     * \param Id
     */

//    static SModeDescription& getMode(const NWalkyrieModes::ERealMode& modeId)
//    {
//        return Modes[modeId];
//    }

//    void OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode* node);

//    bool transformIntoNextMode();
//    bool transformIntoPreviousMode();
    //getCurrentMode();


//    typedef std::vector<TModeId> TCurrentModes;
//    // Enregistre les id des modes qu'on peut utiliser
//    TCurrentModes _activeSpecs;

//    virtual NWalkyrieModes::ERealMode getRealMode(const TModeId& ) const = 0;

    void update(const irr::u32& elapsedTime);

//    int getFrameFromModeId(const TModeId& );
//    SMeshBuffer
};


#endif
