/**
\file
\author
**/
#ifndef CEnemyFleet_HPP
#define CEnemyFleet_HPP



//#include "CIntrusiveList.hpp"
#include <forward_list>
//std::forward_list
#include <irrlicht.h>
#include <fusion/maths/macros.hpp>
#include <fusion/logging/ILogger.hpp>
#include <array>
#include "IFleet.hpp"
#include "IFleetForwardListBased.hpp"
//#include "../def.hpp"
//#include "../utils/TClock.hpp"


class CPlayer;
class CMissile;
class CBullet;
class CStaticBattery;
class IStaticBattery;
class IPlayableState;



class IMusicManager;
namespace audio {
    class ISoundManager;
}
//class IParticleManager;
class CParticleManager;

//typedef std::list<CStaticBattery*> TTrackedBatteries;
//: public CIntrusiveList
class CEnemyFleet : public IFleetForwardListBased
{

private:
    CParticleManager* _particleMgr;



//    CStaticBattery* getDeadButAllocatedBattery(const EEntityType::EId& type);

    void killEntityNextTo(TBatteryContainer::iterator& );

protected:
    CParticleManager* getParticleManager();

    irr::scene::ISceneNode *_fleetRootNode;

public:

    CEnemyFleet( IPlayableState* state );
//    CEnemyFleet( audio::ISoundManager* ,CParticleManager* );
    virtual ~CEnemyFleet();


    void addConfiguredEntityToAliveBatteries(CStaticBattery* battery);
    irr::scene::ISceneNode * getRootNode() const { return _fleetRootNode;};

    void onTimeoutDisparition( IStaticBattery* );

protected:
    virtual void onCollision(IStaticBattery* entity1,IStaticBattery* entity2);


    //TBulletList::iterator deleteBullet(CBullet&);


};

#endif // CENEMYFLEET_HPP
