/**
\file
\author
**/
#ifndef IFleet_HPP
#define IFleet_HPP



//#include "CIntrusiveList.hpp"
#include <forward_list>
//std::forward_list
#include <irrlicht.h>
#include <fusion/maths/macros.hpp>
#include <fusion/logging/ILogger.hpp>
#include <array>
#include "../def.hpp"
#include "../utils/TClock.hpp"


class CPlayer;
class CMissile;
class CBullet;
class IStaticBattery;
class CStaticBattery;

namespace audio {

class IMusicManager;
class ISoundManager;

}
class IParticleManager;
class IPlayableState;


//typedef std::list<CStaticBattery*> TTrackedBatteries;
//: public CIntrusiveList
class IFleet
{
private:
//    audio::ISoundManager* _soundMgr;
protected:
    IPlayableState* _state;

protected:


    virtual IStaticBattery* getDeadButAllocatedBattery(const EEntityType::EId& type) = 0;
    //removeBattery(CStaticBattery*);


    //! change parent so that it doesn't get displayed once dead
//    irr::scene::ISceneNode *_activeFleetNode;
//    irr::scene::ISceneNode *_cachedFleetNode;

//    audio::ISoundManager* getSoundManager() {return _soundMgr;};

    TTimer::TimeType _elapsedTimeSinceLastCheck;
    TTimer::TimeType _consumingUpdateInterval;      //!< Interval between which we should apply periodic check


    virtual void registerActiveBattery(IStaticBattery* battery) = 0;
//    virtual void cacheBattery(IStaticBattery* battery) = 0;


    IPlayableState* getPlayState() { return _state;};


public:
    /** \brief
     * \todo lui passer
     */

    IFleet( IPlayableState* state );
    virtual ~IFleet();

    /** \brief Is called at long intervals because real time is not necessary and it is consuming
     *
     * \param
     * \param
     * \return
     *
     */
    virtual void sporadicCheck() = 0;

    /** \brief
     *
     * \return Number of entities in this fleet
     *
     */
//    irr::u32 getSize() const { return _activeBatteries.size(); };
    irr::scene::IAnimatedMesh* getMesh(const char* filename);

//    virtual void registerBattery(IStaticBattery* battery) = 0;
//
//
//    virtual void clearCache(IStaticBattery* battery) = 0;
//    //! TODO pvr lui passer un enum
//    virtual void clearCache() = 0;


    // nb of alive entities
    virtual std::size_t getNumberOfActiveEntities() const = 0;

    virtual irr::scene::ISceneNode *getCachedFleetNode()  = 0;
    virtual irr::scene::ISceneNode *getActiveFleetNode()  = 0;

    // TODO faire appel a un node dans IPlayableState ?
//    irr::scene::ISceneNode * getRootNode() const { return _activeFleetNode;};

//    static void clearDeadPool();
//    static void destroyAll();
//    void killAllAlive();


//    void killBattery( IStaticBattery* );
//    void killBattery( TBatteryContainer::iterator& it);


    // TODO renommer en drawHitBoxes ? enableBoxes ?
    void draw();


    /**
    * Used from Lua
    * \param
    *
    **/
//    CStaticBattery* addStaticBattery(const char* model);
    CStaticBattery* createAndConfigureStaticBattery();

    //CStaticBattery* createAndSetupBattery(CStaticBattery* battery);
//    CMissile* addMissile(const char* model,
//                        const irr::core::vector3df& position,
//                        CStaticBattery* target,
//                        const irr::core::vector3df& speed
//                        );

    //inline,const TVector3df& position
    //,const TVector3df& position
    CBullet* createAndSetupBullet(const char* model,const float& angleDeg);
    CBullet* createAndSetupBullet(const char* model,const TVector3df& forward );

    //
    CMissile* createAndSetupMissile(const char* model,const TVector3df& forward,const TVector3df& position );


    /// TODO old
    virtual IStaticBattery* getNearestEnemy(const TVector3df& position) = 0;

    // TODO passer un forward_list
    IStaticBattery* getNextTarget(const std::list<IStaticBattery*>& list);

    // Special
//    virtual bool checkCollisions(IFleet* fleet) = 0;

    /** \brief
     * \note Should be called when overriden to call adequatly periodicCheck()
     * \param
     * \param
     * \return
     *
     */

    virtual void update(const TTimer::TimeType&) ;



    // onFadingDisparition
//    virtual void onTimeoutDisparition( IStaticBattery* ) = 0;

protected:
    virtual void onCollision(IStaticBattery* entity1,IStaticBattery* entity2) = 0;
    //TBulletList::iterator deleteBullet(CBullet&);


};

#endif // CENEMYFLEET_HPP
