/**
* \file menu.cpp
*
* utiliser la camera de gameengine ou la sienne propre ?
*/
#include "CMenuState.hpp"
#include "COptionsState.hpp"
#include "CScoreState.hpp"
#include "CDummyPlayState.hpp"
#include "IPlayStateLua.hpp"
#include "CCreditsState.hpp"
#include "../game_engine.hpp"
#include <vector>
#include <fstream>
#include "../config.hpp"
#include "../IdList.hpp"
//#include "../entities/IMultiModeTransformer.hpp"
#include "../utils/CBitSet.hpp"
#include "../audio/ISoundManager.hpp"
#include "../audio/ISound.hpp"
#include <luabind/version.hpp>



using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;


DECLARE_GAME_SINGLETON( CMenuState )


CMenuState::CMenuState() :
IGameState("Main menu",
           true,        //!< showCursor
           true,
           true,
           false,
           true
           ),
_menu(0),
_skybox(0),
_hoverSound(0),
_buildInfoText(0)
{


//    Required.push_back( &MainTab );
//    Required.push_back( &_skybox );
    ADD_REQUIRED( _skybox , "Skybox");
}




CMenuState::~CMenuState()
{


}



bool
CMenuState::load(CGameEngine* engine,irr::scene::ISceneManager* smgr,irr::video::ITexture* screenshot)
{
    _menu = 0;
//    Scene = engine().getSceneManager();

    // TODO that should be set via CGameEngine, as parameters no call through parent
    IGameState::load( engine,smgr,screenshot );

    /// Create initial menu
    GUI_CreateMainMenu();
    //scene::ISceneManager* smgr = scene();


// TODO pas de camera active
    //scene::ICameraSceneNode* camera = engine().smgr->addCameraSceneNode(
    scene::ICameraSceneNode* camera = smgr->addCameraSceneNode(
                                0,
                                core::vector3df(0, 0, -5),
                                core::vector3df(0, 0, 0)
                                );
    //engine->getCamera();
    //engine->smgr->setActiveCamera();
    //addCameraSceneNodeMaya  ();
    #ifdef DEBUG
        camera->setName("Camera");
    #endif
    camera->setTarget(TVector3df(0,0,0));


    scene::ISceneNodeAnimator* anim = smgr->createFlyCircleAnimator(
                                core::vector3df(0,0,0),     //center
                                20.0f,                      //radius
                                0.0001,                     //speed
                                core::vector3df(0.f, 1.f, 0.f), //direction
                                0,                          //start position
                                0                           //raidus ellipsoid
                                );

    camera->addAnimator(anim);

    #ifdef DEBUG
        camera->setName("Camera animator");
    #endif

    video::IVideoDriver* driver = engine->driver();

    _skybox = scene()->addSkyBoxSceneNode(
            driver->getTexture("images/irrSkyBox/irrlicht2_up.jpg"),
            driver->getTexture("images/irrSkyBox/irrlicht2_dn.jpg"),
            driver->getTexture("images/irrSkyBox/irrlicht2_lf.jpg"),
            driver->getTexture("images/irrSkyBox/irrlicht2_rt.jpg"),
            driver->getTexture("images/irrSkyBox/irrlicht2_ft.jpg"),
            driver->getTexture("images/irrSkyBox/irrlicht2_bk.jpg")
    );

    #ifdef DEBUG
        _skybox->setName("Main menu skybox");
    #endif

    //scene::ISceneNode* skydome= game->smgr->addSkyDomeSceneNode(game->driver->getTexture("media/skydome.jpg"),200,60,1.f,2.0f,50);



    ////////////////////////////////////////////
    ///     Load hover sound
    ////////////////////////////////////////////
//    _hoverSound.reset(
//                engine().getSoundManager()->getSound( "sounds/menu_hover.wav")
//                );

//    Required.push_back( _menu );
//    Required.push_back( &_skybox );


    return true;
}

//
//bool
//CMenuState::isLoaded() const
//{
//    return (_menu != 0);
//}


/**** Function unload() ****/
void
CMenuState::unload()
{

    if(_menu != nullptr)
    {
        _menu->remove();
    }

    engine().getSoundManager()->collectGarbage();
};


std::wstring
CMenuState::generateDebugData() const
{
    //
//    stringw desc(L"v");
//    desc += conf::_GAME_VERSION;
//    desc += __DATE__;
//    desc += "\nLuabind version: ";
//    desc += LUABIND_VERSION;
    const ICameraSceneNode* cam = scene()->getActiveCamera();
    vector3df camPos = cam->getPosition();

//    std::wstring ( L"Camera pos (x/y/z): ").append( camPos.X ).append( L"/" ).append( camPos.Y ).append( L"/" ).append( camPos.Z );
    return std::wstring(L"Unknown");
}



void
CMenuState::onResume()
{
    //
    _menu->setVisible(true);

    // TODO supprimer l'effet
//    postProcessingFramework()->removePostProcessingEffect(_materialIds[0]);
//    postProcessingFramework()->removePostProcessingEffect(_materialIds[1]);
}






void
CMenuState::onHold()
{

    //

//    _menu->setVisible(false);

	core::stringc shaderExt = ".glsl";


//removePostProcessingEffect
//	_materialIds[0] = postProcessingFramework()->addPostProcessingEffectFromFile(core::stringc("shaders/BlurHP") + shaderExt) ;
//	_materialIds[1] = postProcessingFramework()->addPostProcessingEffectFromFile(core::stringc("shaders/BlurVP") + shaderExt) ;

    //tab->setEnabled (false);

}


/**
TODO Detecter les changements pr demander si le joueur est sur de vouloir rebooter graphisme:
EGET_EDITBOX_ENTER
EGET_TAB_CHANGED
EGET_CHECKBOX_CHANGED
EGET_EDITBOX_CHANGED
EGET_MENU_ITEM_SELECTED,
EGET_COMBO_BOX_CHANGED,
**/

bool
CMenuState::OnEvent(const SEvent& event)
{


	switch (event.EventType){

        case EET_MOUSE_INPUT_EVENT :

            if(event.MouseInput.isLeftPressed () ){

            }
            break;


    /////////////////////////////////////////////////////
    ////    Change model
    /////////////////////////////////////////////////////
    case EET_KEY_INPUT_EVENT:
        if(!event.KeyInput.PressedDown)
        {
            return false;
        }

        break;

	    case EET_GUI_EVENT:
    {
        IGUIElement* caller = event.GUIEvent.Caller;
		s32 id = event.GUIEvent.Caller->getID();
		//IGUIEnvironment* env = gui();



		switch(event.GUIEvent.EventType)
		{


        //case EGET_ELEMENT_LEFT: break;

//        case EGET_ELEMENT_FOCUSED:
//        case EGET_ELEMENT_FOCUS_LOST :
        case EGET_ELEMENT_HOVERED:
            if(caller->getType() == EGUIET_BUTTON)
            {

                _INFO << "button hovered";
//
//                if(_hoverSound){
//    //                _INFO << "Button hovered caller [" << caller << "] menu [" << _menu << "] editbox [" << _editBox << "]";
//                    _hoverSound->stop();
//                    _hoverSound->play();
//                }
//                else {
//
//                    _LOG_WARNING << "Could not play sound on mouse over";
//                }
            }


            break;

		case EGET_ELEMENT_CLOSED:
//		    if(id == NGuiId::CreditsWindow){
//                //_menuState = NGuiIdState::MainMenu;
//                changeInternalState(NGuiIdState::MainMenu );
//                // Prevents irrlicht from deleting window
//                return true;
//		    }
		    break;

		case EGET_BUTTON_CLICKED:
			switch(id)
			{

                case NGuiId::QuitGame:
                    //_INFO << "closing game";
                    _INFO << "user asked to quit";
                    engine().Quit(); //device->closeDevice();
                    return true;

                case NGuiId::Play:
                    {
//                        engine().replaceTopMostState( CDummyPlayState::instance() );
//::instance
                        engine().pushState( new CDummyPlayState() );
//                        engine().pushState( new CLuaPlayState(0,"levels/tutorial.lua") );
                    }

                    return true;

                case NGuiId::Credits:
                    // faire defiler du texte
                    {
                    }
                    engine().pushState(
//                                CCreditsState::instance()
                                new CCreditsState()
                                       );
                    break;


                case NGuiId::ViewScores:
                    //_overallSet->setAlignment( EGUIA_SCALE, EGUIA_SCALE, EGUIA_SCALE, EGUIA_SCALE);
                    // On se place dans un cas special de cet etat false,
                    {
//                        IBasicGameStatePtr scoreState(new CScoreState( irr::core::rectf(0.2f,0.2f,0.8f,0.8f) ) );
//                        engine().PushState( scoreState );
                    }
                    break;

                case NGuiId::Options:
                    // afficher a gauche en surbrillance le truc
                    //," adding options state"
                    {
//                        engine().pushState(
//                                    new COptionState( engine().GameConfig )
//                                           );

                        engine().pushOptionsState( );

                    }

                    break;

                case NGuiId::SetModelToYF21:
                    //engine().smgr,
//                    engine().getPlayer()->setupAsModel(  NWalkyrieModel::YF21);
                    break;

                case NGuiId::SetModelToYF19:
//                    engine().getPlayer()->setupAsModel(  NWalkyrieModel::YF19);
                    break;

                default:
                    return false;
			}
			break;

		default:
			break;
    }
	}
	default: break;


}
    return false;
}



/// \function Draw()
void
CMenuState::Draw()
{


// Xeffect hack
//    engine().driver()->setMaterial( engine().driver()->getMaterial2D() );

    scene()->drawAll();

    _menu->draw();

    // Display 2D sprites of where clicked
    for(TSpritesMap::iterator i( _sprites.begin() ), end(_sprites.end());i != end;++i)
    {

        i->draw( engine().driver() );
    }


    _buildInfoText->draw();
}



/// mettre a jouer la camera ici
void
CMenuState::onUpdate(const TTimeUnit& elapsedTime)
{

    // TODO a deplacer
//    _LOG_DEBUG << "Start updating CMenuState";

//    const TTimeUnit elapsedTime = engine().getElapsedTime();

//    engine().getPlayer()->update( elapsedTime );
//    engine().getPlayer()->processTransformations();

    /////////////////////////////////////////////////
    /// Update sprites
    /////////////////////////////////////////////////
    //boost::is_null(

    for(TSpritesMap::iterator i( _sprites.begin() ), end(_sprites.end());i != end;++i)
    {

        //C2DSprite* sprite = i;

        // si explosion terminee
        if( i->update(elapsedTime) )
        {
            //i.release();
            //delete sprite;
            i = _sprites.erase(i);
            //continue;
            _INFO << "sprite To Remove";
        }

    }
}



/// Create main menu ( = 1st to be displayed )
// Faire un menu de taille dynamique
void
CMenuState::GUI_CreateMainMenu()
{


    ////////////////////////////////////////////////////////////////
    ////           Create main buttons
    ////////////////////////////////////////////////////////////////
    gui::IGUIElement* elem = gui()->getRootGUIElement();
//    _INFO << "Root ELement rect" << elem->getAbsoluteClippingRect().UpperLeftCorner.X
//            << "/" << elem->getAbsoluteClippingRect().LowerRightCorner.X;

    _menu 	= gui()->addTab( irr::core::recti(0,0,0,0), gui()->getRootGUIElement());
    _menu->setRelativePositionProportional( core::rectf(0.1f,0.4f,1.f,1.f));
    _menu->setDrawBackground(true);




    recti rectButton( conf::_MENU_BUTTON_RECT );

	// faudriat les mettre dans un mm container
	gui()->addButton(rectButton, _menu,
                    NGuiId::Play,
                    L"Play",
                    L"Launches a new game");

    rectButton += conf::_BUTTON_GAP;

    gui()->addButton(rectButton, _menu,
                    NGuiId::Options,
                    L"Options",
                    L"Tweak graphics, sound & controls");


    rectButton += conf::_BUTTON_GAP;
    gui()->addButton(rectButton, _menu,
                    NGuiId::ViewScores,
                    L"Scores",
                    L"View scores");
    rectButton += conf::_BUTTON_GAP;

    //rect<s32>(0,3*_HEIGHT_DELTA,110,3*_HEIGHT_DELTA + 32)
    gui()->addButton(rectButton, _menu,
                    NGuiId::Credits,
                    L"Credits",
                    L"Staff members");
    rectButton += conf::_BUTTON_GAP;

//rect<s32>(0,4*_HEIGHT_DELTA,110,4*_HEIGHT_DELTA + 32)
	gui()->addButton(rectButton, _menu,
                    NGuiId::QuitGame,
                    L"Quit",
                    L"Exits Program");

    //rectButton.Lowern

    decal( rectButton, 100, 50);
	gui()->addButton(rectButton, _menu,
                    NGuiId::SetModelToYF19,
                    L"YF-19",
                    L"Change plane");

    //rectButton.

    xDecal( rectButton, 30);
	gui()->addButton(rectButton, _menu,
                    NGuiId::SetModelToYF21,
                    L"YF-21",
                    L"Change plane");



    ////////////////////////////////////////////////////////////////
    ////           Create text displaying build version
    ////////////////////////////////////////////////////////////////
 // todo faut que ca s'adapte a la taille de la fenetre pr tenir sur une ligne !!!
    stringw desc(L"v");
    desc += conf::_GAME_VERSION;
    desc += __DATE__;
    desc += "\nLuabind version: ";
    desc += LUABIND_VERSION;
    //desc += " at ";
    //desc += __TIME__;


//    bool border=false, bool wordWrap=true, IGUIElement *parent=0, s32 id=-1, bool fillBackground=false)=0
    IGUIStaticText* text = gui()->addStaticText  (
                                                  desc.c_str()
                                                  , rect<s32>(0,0,300,80)
                                                  , false           //!< border
                                                  , true            //!< Wordwrap
                                                  , _menu           //!< Parent
                                                  , NGuiId::BuildInfo   //!< Id
                                                  , false               //!< fillBackground
                                                  );
    //text->setMinSize(core::dimension2du(text->getTextWidth(),text->getTextHeight()));
    core::position2di pos(engine().getScreenSize().Width-text->getTextWidth(),engine().getScreenSize().Height-text->getTextHeight());
    text->setRelativePosition(pos);
    text->setWordWrap(false);

    _buildInfoText = text;

    MainTab = _menu;

}

