/**
* \file single.cpp
*/
#include "IPlayStateLua.hpp"
#include <cmath>
#include <irrlicht.h>
#include "../entities/player.hpp"
#include "../config.hpp"
#include "../game_engine.hpp"
//#include "../states/CMenuState.hpp"
#include "../states/COptionsState.hpp"
#include "../states/CScoreState.hpp"
#include "../states/CErrorState.hpp"
#include "../states/CDialogStateLua.hpp"
//#include "../states/CTransitionState.hpp"
#include "../IdList.hpp"
#include "../fx/CParticleManager.hpp"
#include "../utils/CBitSet.hpp"
#include "../binds/binds.hpp"
#include "../entities/IMultiModeTransformer.hpp"
#include "../fleets/IFleet.hpp"
#include <fusion/scripting/CLuaThread.hpp>
#include <fusion/scripting/CLuaVM.hpp>
#include <fusion/maths/macros.hpp>
#include <fusion/core/string.hpp>
//#include "../levels/ILevel.hpp"
//#include "../levels/CSandBoxLevel.hpp"
#include "../fleets/CEnemyFleet.hpp"

const int _OSCILLATION_NUMBER = 3;


using namespace irr;
using namespace video;
using namespace core;
using namespace scene;
using namespace fus;


DECLARE_GAME_SINGLETON( CLuaPlayState )




// Passer le nom du script en parametre ?

//! Constructor
CLuaPlayState::CLuaPlayState(lua_State* mainState, const std::string& levelFilename) :
IPlayableState("Lua play state")
, _levelFilename( levelFilename )
, MainVM(0)
, Thread(0)
//, MainVM(mainState)
{


};

//! Destructor
CLuaPlayState::~CLuaPlayState()
{
    //_world->remove();
//    delete _script;
}



void
CLuaPlayState::loadLevel(const char* level)
{

}


bool CLuaPlayState::load(CGameEngine* engine,irr::scene::ISceneManager* smgr,irr::video::ITexture* screenshot)
{

   if (! IPlayableState::load(engine,smgr,screenshot) ) return false;


    ////////////////////////////////////////////////////////////////////////////
    ////    Create Camera
    ////////////////////////////////////////////////////////////////////////////
    const core::vector3df pos(0,10,0);
    const core::vector3df target(0,0,0);

    //!bool cloneContent=false
    //engine().scene()->createNewSceneManager(false);

//    scene::ISceneManager* smgr = scene();
    scene::ISceneNode * skydome = smgr->addCameraSceneNode (
                0       //!< parent
                , pos   //!< position
                , target    //!< Target
//            const core::vector3df &  position = core::vector3df(0, 0, 0),
//  const core::vector3df &  lookat = core::vector3df(0, 0, 100),
//  s32  id = -1,
//  bool  makeActive = true
        );

    #ifdef DEBUG
        skydome->setName("Skydome");
    #endif

    //smgr->getRootSceneNode()->addChild( _player->_walkyrie->getNode() );


    //! show cursor
//    engine().showCursor(true);
    // leur donner des IDS
    smgr->addSkyDomeSceneNode(
                            engine->driver()->getTexture("images/skydome.jpg")
//                              , u32 horiRes=16, u32 vertRes=8, f32 texturePercentage=0.9, f32 spherePercentage=2.0, f32 radius=1000.f, ISceneNode *parent=0, s32 id=-1)
                              );

    //if( MainVM )

    if( !setupLuaThread() )
    {
        //!
        _LOG_ERROR << "Could not init lua ";

        return false;
    }

    return true;
}



void
CLuaPlayState::unload()
{

}


float
CLuaPlayState::getProgression() const
{


    //
    return 0;
}



// setupLuaThread/context
bool
CLuaPlayState::setupLuaThread()
{
//->createThread()

//    CLuaVM& vm = engine().getScriptingVM();

    ////////////////////////////////////////////////////////////////////////////
    ////    We first need to setup the global environment
    ////////////////////////////////////////////////////////////////////////////
    try
    {



        //! Load lua engine
        MainVM = new CLuaVM();

        MainVM->bind( bindEngineToLua() );
        MainVM->bind( bindPlayerToLua() );
        MainVM->bind( bindFleets() );
        MainVM->bind( createLoggerScope() );
//        vm->bind( bindSound() );


        luabind::object global_vars;

        MainVM->getGlobals(global_vars);

        //global_vars["Engine"] = engine();
        global_vars["Player"] = &getPlayer(0);
        global_vars["MainState"] = this;
        global_vars["EnemyFleet"] = getEnemyFleet();
//        global_vars["AlliedFleet"] = getAlliedFleet();



    //    GET_FOLDER(conf::scripts,"init_engine.lua");
        // TODO lancer des exceptions
        //
        if( !  ( MainVM->RunFile("scripts/init_engine.lua") == true && MainVM->RunFile(_levelFilename.c_str() ) == true) )
        {

            _LOG_ERROR << MainVM->getErrorDescription();
            return false;
        }

        // MAintenant fut le runner
        // Le execute est pas bon
//        else if( !MainVM->execute() )
//        else if( !MainVM->execute(0,0) )
////        else
//        {
//            // Message handler
////            lua_pcall(lua_State *L, int nargs, int nresults, int msgh);
////int lua_pcallk (lua_State *L, int nargs, int nresults, int errfunc,int ctx, lua_CFunction k);
//
//
//
//            _LOG_ERROR << MainVM->getErrorDescription();
//            return false;
//
////            int idx = MainVM->pushMessageHandler();
////            lua_pcall(MainVM->getVM(),0,0, idx );
//////            MainVM->remove()
////            lua_resume( thread, 0, nargs);
////            //lua_resume( MainVM->getVM() ,
//
//        }

//        MainVM->bind( bindLevelHandlerToLua() );
//        vm->bind( bindConfigStructToLua() );

//
////        Thread.reset( new fus::CLuaThread( MainVM->getVM() ) );
        Thread = new fus::CLuaThread( MainVM->getVM() );
//        //TScriptingVM& vm = engine().
//
//
//
//        //! load level
//        // ptet qu'on pourrait faire un require "init_engine.lua" au lieu de le charger  part
////        if( ! Thread->loadFile( _levelFilename.c_str(),"bt") )
//        if( (! Thread->Run( _levelFilename.c_str() ) )
//           ||
//           )
//        {
//            //"Couldn't load level [ " << _levelFilename << "]:\n" <<
//            _LOG_ERROR << Thread->getErrorDescription();
//            engine().popupMessage(L"Error while loading lua engine", Thread->getErrorDescription() );
//            return false;
//        }
////        else if( ! Thread->execute(0,0) )
//        else
//        {
//            // this should be a pcall here
//            int result = lua_resume( Thread->getVM(), 0, 0);
//
//
//
//        }
//
//        //lua_isthread
//
//        // Force text files !
//        //luaL_loadfilex( Thread , "dialog2.lua" ,"t");
//


    //TODO
        //global_vars["SoundManager"] = engine().getSoundManager();

    }
    catch(std::exception &e)
    {
        _LOG_ERROR << "Exception catched : " << e.what();
        engine().popupMessage(L"Error while loading lua engine", e.what() );
        return false;
    }


    ////////////////////////////////////////////////////////////////////////////
    ////    Create Camera
    ////////////////////////////////////////////////////////////////////////////


// TODO faire en sorte que le message d'erreur s'affiche jusqu' ce qu'il
    // soit resolu
    // quitter le jeu
//    const char* filename = conf::_LUA_STARTER_SCRIPT;
//
//
//_levelFilename
//
//
//    bool ret =  vm.RunFile(filename);
//    if( !ret )
//    {
//
//        _LOG_ERROR << " script [" << filename << "] not loaded";
//
//        engine().popupMessage(L"Main Lua script error",vm.getErrorDescription() );
//        return false;
//    }

    return true;
}




void
CLuaPlayState::startDialog(const std::string& dialogFilename)
{
    //
    engine().pushState( new CDialogStateLua( Thread->getVM(), dialogFilename ) );

    int ctx;
    lua_getctx( Thread->getVM(), &ctx);
    //int lua_yieldk  (lua_State *L, int nresults, int ctx, lua_CFunction k);
//    lua_pushinteger(L,Number);

    //continuationFunc
    lua_yieldk( Thread->getVM(), 0,ctx,0);
    // TODO stop script
//    lua_yieldk()

}


std::wstring
CLuaPlayState::generateDebugData() const
{


//    text.append( L"Level filename: ").append( 4 );
    return std::wstring (L" Level filename");
}





/// Function Update()
void
CLuaPlayState::onUpdate(const TTimeUnit& elapsedTime)
{

//    _LOG_WARNING << "starting updating CLuaPlayState with mode ["  << "]";
//(this->*_updateFunctions[ getInnerState() ])();
    int result = 0;
    int nargs = 0;

    getPlayer(0).update(elapsedTime, engine().getCachedInput() );


    //! should wait for at least one param ?
    //! resume should be given
//    luaL_loadstring(Thread->getVM(), );
    Thread->loadString( "TaskManager:update();" );
    result = lua_resume(Thread->getVM(), 0, 0 );


    if (result == LUA_YIELD)
    {
        _INFO << "Yielding";
//            getUserReply(thread);

        nargs = 1;
    }
    else if (result == LUA_OK)
        {
        _INFO << "script finished";

        // exit state
//        engine().popupMessage(L"Level finished", "Level finished" );
    }
    else
    {
        _LOG_ERROR << "we got errors";
        stackDump( Thread->getVM() );

        engine().popupMessage(L"Lua error during update", Thread->getErrorDescription() );

//        break;
    }
}





#if 0

/**
TODO creer un animator pour ca
**/
void
CLuaPlayState::updateCamera()
{

    TVector3df posCamera = _player->_walkyrie->_cameraRecul;


    if(_shakingTimer)
    {

        _shakingTimer->update( engine().getElapsedTime() );
        if( _shakingTimer->reached() ){
        //if(_shakingTimer->update( engine().getElapsedTime() )){
            //cam->getTarget() + core::vector3df(0,-4,+20)
            //_CAM_POS
            //_camera->setPosition( _camPosBackup );
            delete _shakingTimer;
            _shakingTimer = 0;
            _LOG_DEBUG << "END SHAKING";
        }
        else {
//1.f/_shakingTimer->getElapsedTime()
            double ratio = _shakingTimer->getAdvancement();
            // Le mettre
            double intensite = 20.f*_FUSION_POW2(1.f-ratio);
            //float coeff = _SHAKING_LENGTH/(_OSCILLATION_NUMBER*M_PI);
            // Le ratio est cense etre compris entre 0 et 1

            //getElapsedTime()/_SHAKING_LENGTH;
            intensite *= std::sin( 4* PIperso * ratio );
            _INFO << "shaking d'intensite/ratio " << intensite << "/" << ratio;

            TVector3df decalage(intensite,0,0);


            //_camera->setPosition(_camPosBackup + decalage);
            posCamera += decalage;
            //cam->setPosition();
        }
    }
    // if player transforming
    //else

    /////////////////////////////////////////////////////
    //////  Debug des specs
    /////////////////////////////////////////////////////
    _camera->setPosition( posCamera );
}



void
CLuaPlayState::shakeCamera()
{

    _INFO << "shaking camera";
    // If already shaking
    if(_shakingTimer){
        _shakingTimer->restart();
    }
    else {
        _shakingTimer = new TTimer( conf::_SHAKING_LENGTH);
        //
        _camPosBackup = _camera->getPosition();
    }

}

#endif





// TODO deplacer ca dans lua
/*
void
CLuaPlayState::update(const TTimer::TimeType& elapsedTime){




//    _layer->getMaterial(0).getTextureMatrix(0).setTextureTranslate(0.f,-percievedSpeed);




    speed = _player->_walkyrie->getSpeed(SModeDescription::DefaultForward)/100.f;

    // plus on est eloigne du bas de l'ecran plus la sensation de vitesse
    float ecart = (_player->getPosition().Z- conf::_LOWER_LIMIT);
    ecart /= (conf::_UPPER_PART - conf::_LOWER_LIMIT);
    // Comme ca on a un ecart < 1

    //_INFO << "ecart " << ecart;
    speed += ecart/1000.f;// /10.f


    //_INFO << "upper progress" << _levelMgr._upperProgress/100.f;

    percievedSpeed += (speed);

    // TOOOOOOODOOOO : a retirer !!
    //BUG
    getLevelManager().updatePlayerProgress(percievedSpeed);


    //_INFO << "speed" << translation;

    // Selon l'avancement du joueur, incliner plus ou moins la camera
    this->updateCamera();


}
*/


////setUp cameras
//void
//CLuaPlayState::setupCameras(){
//
//    //irr::core::dimension2du dim =  engine().driver->getScreenSize();
//    //_cameras[Scene] =
//    _camera = scene()->addCameraSceneNode();
//                    /*0,  //!< parent
//                    //_CAM_POS, //!< cam pos
//                    //core::vector3df(0, 0, 0)    //!< lookat
//
//                    );*/
//
//    _camera->setPosition( _player->_walkyrie->_cameraRecul );
//
//    scene()->setActiveCamera(_camera);
//
//}



//! Render a frame
// en gros l'ecran a une taille de 60
//void
//CLuaPlayState::Draw()
//{
//
////    _LOG_DEBUG << "starting drawing CLuaPlayState";
//
//    const irr::core::dimension2du& dim =  engine().getScreenSize();
//    TVector3df start , end;
//
//    irr::core::recti area;//(core::position2di(0,0),dim);
//
////    video::ITexture* warningImg = engine->driver->getTexture("images/warning.jpg");
////
//
//    // d'abord on dessine la scene
//    int bandWidth = conf::_SIDE_BAND_PERCENTAGE*dim.Width;
//    area.UpperLeftCorner = position2di(bandWidth,0);
//    area.LowerRightCorner  = position2di(dim.Width-bandWidth,dim.Height);
//    engine().driver()->setViewPort(area);
//    //engine->smgr->setActiveCamera(_cameras[Scene]);
//
//
//    // Draw scene
//    scene()->drawAll();
//
//
//
//    // Left HUD
//    //area.UpperLeftCorner    = ;
//    //area.LowerRightCorner   = core::position2di(dim.Width,dim.Height);
//    engine().driver()->setViewPort(core::recti(core::position2di(0,0),core::position2di(dim.Width,dim.Height )));
//    //DrawLeftHUD(core::recti(core::position2di(0,0), core::position2di(bandWidth,dim.Height )));
//    DrawLeftHUD(core::position2di(0,0));
//    //DrawRightHUD(core::recti(core::position2di(dim.Width-bandWidth,0), core::position2di(dim.Width,dim.Height )));
//    DrawRightHUD(core::position2di(dim.Width-bandWidth,0));
//}


void
CLuaPlayState::onHold()
{


}






/// \function HandleEvents
bool
CLuaPlayState::OnEvent(const irr::SEvent& event)
{

    if(handleMainEvents(event))     return true;


    //! According to event type
    switch(event.EventType)
    {

        // Handle keys
        case EET_KEY_INPUT_EVENT :

            // check that's no key up
            if(!event.KeyInput.PressedDown)
                return false;

            switch (event.KeyInput.Key)
            {



                // cree une explosion avec spark
//                case irr::KEY_KEY_G:
//                    {
//                    //boost::any pos;
//                    //engine().addMessage(NMessageType::CreateExplosion,pos);
//
//                    //_levelMgr.addExplosion(irr::core::vector3df(5,0,0));
//                        _INFO << "Add spark explosion";
//                    //engine()._particleManager
//                        //ISceneNode* node = CGameEngine::getParticleManager()->createExplosion();
//                        //node->setParent( scene()->getRootSceneNode() );
//                        addSimpleExplosion( TVector3df(0,0,0) );
//                        this->shakeCamera();
//                    }
//                    break;
//
//                case irr::KEY_KEY_N:
//
//                    shakeCamera();
//                    break;

                // Tue le joueur
                case irr::KEY_KEY_M:

                    _INFO << "Mort du joueur";
//                    getPlayer(0).kill();
//                    getLevelManager().updateState();
                    break;

                // Reload level
                case irr::KEY_KEY_R :

                    if(event.KeyInput.PressedDown)
                    {
                        // TODO reload script de base

                        _INFO << "Reloading level...";
//                        _initialized = (setupLuaThread() && reloadLevel() );
//                        if(_initialized){
//                            _INFO << "Reset successful";
//                        }
//                        else {
//                            _LOG_WARNING << "Reseting context failed";
//                        }
//                        engine().replaceTopMostState( new CLuaPlayState(0, _levelFilename) );
                    }
                    break;

                // Reload
                case irr::KEY_KEY_D :
                // TODO tuer le joueur
                    //_player.Kill();
                    //_INFO << "setPlay state to dead";
                    //getLevelManager()._playState = CLevelManager::PlayerDead;

                    break;

                default:
                    break;
            }
            break;


        default:
            break;
    } // end 1nd switch

    return false;
}




void
CLuaPlayState::Draw()
{

//    _INFO << "starting drawing CDummyPlayState";

    const irr::core::dimension2du& dim =  engine().getScreenSize();
    TVector3df start , end;

    irr::core::recti area;//(core::position2di(0,0),dim);

//    video::ITexture* warningImg = engine->driver->getTexture("images/warning.jpg");
//

    // d'abord on dessine la scene
    int bandWidth = conf::_SIDE_BAND_PERCENTAGE*dim.Width;
    area.UpperLeftCorner = position2di(bandWidth,0);
    area.LowerRightCorner  = position2di(dim.Width-bandWidth,dim.Height);
    engine().driver()->setViewPort(area);
    //engine->smgr->setActiveCamera(_cameras[Scene]);


    driver()->setRenderTarget(video::ERT_FRAME_BUFFER,true,true);

    // Draw scene
    scene()->drawAll();



    // Left HUD
    //area.UpperLeftCorner    = ;
    //area.LowerRightCorner   = core::position2di(dim.Width,dim.Height);
//    engine().driver()->setViewPort(core::recti(core::position2di(0,0),core::position2di(dim.Width,dim.Height )));
    //DrawLeftHUD(core::recti(core::position2di(0,0), core::position2di(bandWidth,dim.Height )));
//    DrawLeftHUD(core::position2di(0,0));
    //DrawRightHUD(core::recti(core::position2di(dim.Width-bandWidth,0), core::position2di(dim.Width,dim.Height )));
//    DrawRightHUD(core::position2di(dim.Width-bandWidth,0));



}


